/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.chaines;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import visuAnalec.*;
import visuAnalec.Message.*;
import visuAnalec.elements.*;
import visuAnalec.texte.*;
import visuAnalec.texte.PanneauTexte.*;
import visuAnalec.util.*;
import visuAnalec.util.GVisu.*;
import visuAnalec.vue.*;
import visuAnalec.vue.Vue.*;

/**
 *
 * @author Bernard
 */
public class VisuChaines extends JFrame implements VueListener, ActionListener {
  private static Color[] couleursNbElts = {GVisu.getCouleurSansValeur(),
    GVisu.getCouleur(0), GVisu.getCouleur(3), GVisu.getCouleur(1)
  };
  private static int[] seuilsCouleursNbElts = {3, 10};
  private static LegendeLabel[] legendeNbElts = {new LegendeLabel("pas de chaîne associée", Color.WHITE),
    new LegendeLabel("chaîne d'un seul chaînon", couleursNbElts[0]),
    new LegendeLabel("chaîne de 2-"+Integer.toString(seuilsCouleursNbElts[0])
    +" chaînons", couleursNbElts[1]),
    new LegendeLabel("chaîne de "+Integer.toString(seuilsCouleursNbElts[0]+1)+"-"
    +Integer.toString(seuilsCouleursNbElts[1])+"  chaînons", couleursNbElts[2]),
    new LegendeLabel("chaîne de plus de "+Integer.toString(seuilsCouleursNbElts[1])
    +" chaînons", couleursNbElts[3])
  };
  private Vue vue;
  private ModeleChaines donneesChaines;
  private String typeChaines;
  private String typeUnites;
  private TypeComboBox saisieTypeChaines;
  private TypeComboBox saisieTypeUnites;
  private Val0ComboBox saisieChampAffiche;
  private JList legendeChampAffiche;
  private GChaines panneauGraphique;
  private PanneauAffChainesTexte panneauTexte;
  private PanneauEditeur panneauEditeur;
  public VisuChaines(Container fenetre, Vue vue, PanneauEditeur pEditeur) {
    super("Représentation des chaînes");
    Point pos = new Point(fenetre.getX()+20, fenetre.getY()+20);
    Dimension dim = new Dimension(fenetre.getWidth(), fenetre.getHeight());
    setLocation(pos);
    setSize(dim);
    this.vue = vue;
    vue.addEventListener(this);
    this.panneauEditeur = pEditeur;
    saisieTypeChaines = new TypeComboBox(Schema.class);
    saisieTypeChaines.setModele(vue.getTypesSchemasAVoir());
    saisieTypeChaines.addActionListener(this);
    saisieTypeUnites = new TypeComboBox(Unite.class);
    saisieTypeUnites.setModele(vue.getTypesUnitesAVoir());
    saisieTypeUnites.addActionListener(this);
    saisieChampAffiche = new Val0ComboBox("Nombre de chaînons");
    saisieChampAffiche.addActionListener(this);
    // Panneau de présentation du graphique
    JPanel pGraphique = new JPanel(new BorderLayout());
    Box commandes = Box.createHorizontalBox();
    commandes.add(Box.createHorizontalGlue());
    commandes.add(new JLabel("Chaînes : "));
    commandes.add(saisieTypeChaines);
    commandes.add(Box.createHorizontalGlue());
    commandes.add(new JLabel("Unites : "));
    commandes.add(saisieTypeUnites);
    commandes.add(Box.createHorizontalGlue());
    commandes.add(new JLabel("Champ à afficher : "));
    commandes.add(saisieChampAffiche);
    pGraphique.add(commandes, BorderLayout.SOUTH);
    panneauGraphique = new GChaines(this);
    JScrollPane scrollGraphique = new JScrollPane(panneauGraphique);
    pGraphique.add(scrollGraphique, BorderLayout.CENTER);
    panneauTexte = new PanneauAffChainesTexte(vue.getCorpus(), this);
    panneauTexte.setTexteVisu();
    JScrollPane scrollTexte = new JScrollPane(panneauTexte);
    legendeChampAffiche = new JList();
    legendeChampAffiche.setCellRenderer(new LegendeCellRenderer());
    JScrollPane scrollLegende = new JScrollPane(legendeChampAffiche);
    JSplitPane split1 = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, scrollTexte, scrollLegende);
    JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT, pGraphique, split1);
    getContentPane().add(split);
    setVisible(true);
    split.setDividerLocation(1./3);
    split1.setDividerLocation(3./4);
    // Fermeture de la fenêtre
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent evt) {
        fermerFenetre();
      }
    });
    // Initialisation
    donneesChaines = new ModeleChaines(vue, panneauGraphique);
    saisieTypeChaines.effSelection();
    saisieTypeUnites.effSelection();
  }
  void afficherOccurrences(Unite unite, Schema chaine) {
    if (chaine!=null)
      panneauTexte.montrerUnite(unite, TypeMarquage.SELECT1_2,
              donneesChaines.getUnitesChaine(chaine), TypeMarquage.SELECT1);
    else
      panneauTexte.montrerUnite(unite, TypeMarquage.SELECT2);

  }
  private void fermerFenetre() {
    vue.removeEventListener(this);
    dispose();
  }
  public void traiterEvent(Message evt) { // très grossier : à améliorer
    switch (evt.getType()) {
      case CLEAR_CORPUS:
        fermerFenetre();
        return;
      case NEW_CORPUS:  // impossible en principe : CLEAR_CORPUS a détruit la fenêtre
        throw new UnsupportedOperationException("Fenêtre chaines présente lors d'un message NEW_CORPUS ???");
      case MODIF_TEXTE:
        fermerFenetre();
        return;
      case MODIF_VUE:
        fermerFenetre();
        return;
      case MODIF_STRUCTURE:
        fermerFenetre();
        return;
      case MODIF_ELEMENT:
//        ElementEvent evtE = (ElementEvent) evt;
//        if (evtE.getModif() != TypeModifElement.BORNES_UNITE) fermerFenetre();
        fermerFenetre();
        return;
      default:
        throw new UnsupportedOperationException("Cas "+evt.getType()+" oublié dans un switch");
    }
  }
  public void traiterAffTexteDoubleClic(Unite unit) {
    Schema chaine;
    if ((chaine = donneesChaines.chainonsUnites.get(unit).chaine)!=null)
      panneauEditeur.editerUniteChaine(unit, chaine);
    else
      panneauEditeur.editerUniteTypeChaine(unit, typeChaines);

  }
  public void traiterAffTexteClicVide() {
    panneauTexte.colorerUnites(donneesChaines.getUnites(), TypeMarquage.FOND1);
  }
  public void actionPerformed(ActionEvent evt) {
    try {
      if (evt.getSource().equals(saisieTypeChaines)||evt.getSource().equals(saisieTypeUnites)) {
        if (saisieTypeChaines.pasdeSelection()||saisieTypeUnites.pasdeSelection()) {
          initVide();
          return;
        }
        try {
          init();
        } catch (Exception ex) {
          JOptionPane.showMessageDialog(this, ex.getMessage(), "Erreur de type", JOptionPane.ERROR_MESSAGE);
          initVide();
          return;
        }
        return;
      }
      if (evt.getSource().equals(saisieChampAffiche)) {
        if (saisieChampAffiche.pasdeSelection()) initCouleursNbElts();
        else initCouleursChamp(saisieChampAffiche.getSelection());
        return;
      }
      throw new UnsupportedOperationException("Evénement non prévu : "+evt.paramString());
    } catch (Throwable ex) {
      GMessages.erreurFatale(ex);
    }
  }
  private void initVide() {
    typeChaines = null;
    typeUnites = null;
    donneesChaines.initVide();
    saisieChampAffiche.setModeleVide();
    panneauTexte.pasDeMarquage();
    panneauTexte.setCurseur(0);
    legendeChampAffiche.setListData(new LegendeLabel[0]);
  }
  private void init() throws Exception {
    typeChaines = saisieTypeChaines.getTypeSelection();
    typeUnites = saisieTypeUnites.getTypeSelection();
    donneesChaines.init(typeChaines, typeUnites, couleursNbElts, seuilsCouleursNbElts);
    initCouleursNbElts();
    saisieChampAffiche.removeActionListener(this);
    saisieChampAffiche.setModele(vue.getNomsChamps(Unite.class, typeUnites));
    saisieChampAffiche.addActionListener(this);
    panneauTexte.colorerUnites(donneesChaines.getUnites(), TypeMarquage.FOND1);
  }
  private void initCouleursNbElts() {
    donneesChaines.setChampAfficheNbElts(couleursNbElts, seuilsCouleursNbElts);
    legendeChampAffiche.setListData(legendeNbElts);
  }
  private void initCouleursChamp(String champ) {
    String[] vals = vue.getValeursChamp(Unite.class, typeUnites, champ);
    LegendeLabel[] legende = new LegendeLabel[vals.length+1];
    HashMap<String, Color> couleursValeursChamp = new HashMap<String, Color>();
    Color couleur;
    for (int i = 0; i<vals.length; i++) {
      couleur = GVisu.getCouleur(i);
      couleursValeursChamp.put(vals[i], couleur);
      legende[i] = new LegendeLabel(vals[i], couleur);
    }
    couleur = GVisu.getCouleurSansValeur();
    legende[vals.length] = new LegendeLabel("<aucune valeur>", couleur);
    couleursValeursChamp.put("", couleur);
    donneesChaines.setChampAffiche(champ, couleursValeursChamp);
    legendeChampAffiche.setListData(legende);
  }
}
